# Caesarova substituční šifra
#
# na základě klíče vyrobíme substituční abecedu, při šifrování
# nahrazujeme písmena otevřeného textu odpovídajícími prvky
# substituční abecedy, při dešifrování se úloha obou abeced
# prohodí

abeceda = "abcdefghijklmnopqrstuvwxyz"

# vytvoření substituční abecedy
#  - cyklický posun o pocet pismen určený číselným klíčem
def subst_abc(klic):
    klic %= len(abeceda) # zajištění správného rozsahu
    return abeceda[klic:] + abeceda[:klic]

# náhrada prvků z 'co' odpovídajícími prvky z 'cim'
def substituce(text, co, cim):
    vysledek = list(text) # budeme pracovat na seznamu
    for i in range(len(vysledek)):
        index = co.find(vysledek[i]) # je znak v 'co'
        if index >= 0:
            vysledek[i] = cim[index] # náhrada z 'cim'
    return "".join(vysledek) # vrátíme řetězec
    
# šifrování
# znaky normální abecedy měníme za prvky substituční abecedy
def zasifruj(text, klic):
    return substituce(text.lower(), abeceda, subst_abc(klic))

# dešifrování
# znaky substutuční abecedy měníme za prvky normální abecedy
def rozsifruj(text, klic):
    return substituce(text.lower(), subst_abc(klic), abeceda)
    
puvodni = \
"Toto je velmi tajna zprava o stavu programovani "\
"Pythonu na nasem gymnaziu, kterou potrebujeme "\
"dorucit svym spoluzakum."
print(puvodni)

print("-----------------------------------")
klic = 4
odeslano = zasifruj(puvodni, klic)
print(odeslano)
prijato = rozsifruj(odeslano, klic)
print(prijato)
print("-----------------------------------")
klic = 12
odeslano = zasifruj(puvodni, klic)
print(odeslano)
prijato = rozsifruj(odeslano, klic)
print(prijato)
